/******************************************************************************
إåե뤽ΣǤ롣
******************************************************************************/

#ifndef TX_H
#define TX_H

#include <stdio.h>		/* FILE */
#include <time.h>		/* time_t */

/*ڽ*/

#define VERSION		"3.02l"			/* Сֹ */

// #ifdef LINUX
//#define TX_DIR      "~/.tx"
//#define TXT_FILE	"lesson"	/* ƥȥե̾tx.txt */
//#define FIG_FILE	"keymap"	/* ޤΥե̾tx.fig */
//#define SCR_FILE	"scores"	/* ե̾tx.scr */
//#define USR_FILE	"usrdata"	/* 桼ե̾tx.usr */
//#else
#define TXT_FILE	"tx.txt"	/* ƥȥե̾ʥǥեȡ */
#define FIG_FILE	"tx.fig"	/* ޤΥե̾ʥǥեȡ */
#define SCR_FILE	"tx.scr"	/* ե̾ʥǥեȡ */
#define USR_FILE	"tx.usr"	/* 桼ե̾ʥǥեȡ */
//#endif
#define PENALTY		5				/* ڥʥƥǡʥǥեȡ */

#define SCOREFILEID	"=== Score File for <<< tx version 3.0x >>> ==="
#define USERFILEID	"=== User File for <<< tx version 3.0x >>> ==="

#define LINES				25		/* ǥץ쥤ιԿ */
#define MAXLIN		((LINES - 5)/2)	/* ʸκԿ */
#define MAXCOL				75		/* ʸΰԤκ */

#define MAXLESSONNUM		200		/* ݤοκ */
#define MAXLESSONNAMELEN	13		/* ݤ̾κʸ */

#define MAXFIGURENUM		25		/* ޤοκ */
#define MAXFIGURENAMELEN	12		/* ޤ̾κʸ */

#define MAXSCORELIN	   (LINES - 5)	/* ȤäƤιԿ */

#define OK			1
#define YES			1
#define NO			0

#ifdef LINUX
#define bell()				putc('\007', stderr)
#define xprintf				printf

// #define xgotoxy(X,Y)		printf("\033[%d;%dH",X+1,Y+1)
#define xgotoxy(X,Y)		printf("\033[%d;%dH",X,Y)
										/*  X ԡ Y إư */
#define xclr2end()			printf("\033[K")
										/* ʹ߹ޤǾõ */
// #define cursor_on()         printf("\033[?25h")
// #define cursor_off()        printf("\033[?25l")
#define cursor_on()         printf("")
#define cursor_off()        printf("")

#define xcolor4text1()		printf("\033[m\033[1;33m")
										/* ƥȤ뿧ʲ */
#define xcolor4text0()		printf("\033[m\033[1;35m")
										/* ߥƥȡʻ翧 */
#define xcolor4ok()			printf("\033[m\033[1;43m")
										/* ֹʡפɽ뿧ʲȿž */
#define xcolor4no()			printf("\033[m\033[1;35m")
										/* Բġפɽ뿧ʻ翧 */
#define xcolor4wrong()		printf("\033[m\033[1;41m")
										/* Ǥɽ뿧ֿȿž */
#define xcolor4xposed()		printf("\033[m\033[1;45m")
										/* ž֤ɽ뿧ʻ翧ȿž */
#define xcolor4dropped()	printf("\033[m\033[1;42m")
										/* æɽ뿧пȿž */
#define xcolor4inserted()	printf("\033[1;46m")
										/* ɽ뿧ʿ忧ȿž */

#define CHAR4DROPPED		'^'	/* æ򼨤̾Υ饯 */

#define xcolornormal()		printf("\033[m")	/* ̾ο */

#else /* not LINUX */
#define bell()				putc('\a', stderr)
#define xprintf				printf

#define xgotoxy(X,Y)		printf("\033[%d;%dH",X,Y)
										/*  X ԡ Y إư */
#define xclr2end()			printf("\033[0K")
										/* ʹ߹ޤǾõ */

#ifdef J3100

#define xcolor4text1()		printf("\033[m")
								/* ƥȤ뿧̾￧ */
#define xcolor4text0()		printf("\033[4m")
								/* ߥƥȡʲ */
#define xcolor4ok()			printf("\033[m")
								/* ֹʡפɽ뿧̾￧ */
#define xcolor4no()			printf("\033[7m")
								/* Բġפɽ뿧ȿž */
#define xcolor4wrong()		printf("\033[7m")
								/* Ǥɽ뿧ȿž */
#define xcolor4xposed()		printf("\033[7m")
								/* ž֤ɽ뿧ȿž */
#define xcolor4dropped()	printf("\033[7m")
								/* æɽ뿧ȿž */
#define xcolor4inserted()	printf("\033[7m")
								/* ɽ뿧ȿž */
#else /* not J3100 */

#define xcolor4text1()		printf("\033[33m")
										/* ƥȤ뿧ʲ */
#define xcolor4text0()		printf("\033[35m")
										/* ߥƥȡʻ翧 */
#define xcolor4ok()			printf("\033[43m")
										/* ֹʡפɽ뿧ʲȿž */
#define xcolor4no()			printf("\033[35m")
										/* Բġפɽ뿧ʻ翧 */
#define xcolor4wrong()		printf("\033[41m")
										/* Ǥɽ뿧ֿȿž */
#define xcolor4xposed()		printf("\033[45m")
										/* ž֤ɽ뿧ʻ翧ȿž */
#define xcolor4dropped()	printf("\033[42m")
										/* æɽ뿧пȿž */
#define xcolor4inserted()	printf("\033[46m")
										/* ɽ뿧ʿ忧ȿž */
#endif /* not J3100 */

#define CHAR4DROPPED		'\x1c'	/* æ򼨤̾Υ饯 */

#ifdef DOSV
#define xcolornormal()		printf("\033[0;1m")	/* ̾ο */
#else /* not DOSV */
#define xcolornormal()		printf("\033[m")	/* ̾ο */
#endif /* not DOSV */
#endif /* not LINUX */



/*ڥȥ饯*/

/******************************************************************************
̾	Myfloat
ڲ	ưǤ롣
			number 10  precision ˤɽ魯
******************************************************************************/
struct Myfloat_ {			/* ư */
	long	number;			/* number 10  precision ˤɽ魯*/
	int		precision;		/* ʲΥ */
};

typedef struct Myfloat_ Myfloat;


/******************************************************************************
̾	Figure
ڲ	ް示Ĥб롣
			̾ name ȳƹԤؤΥݥ󥿤 fig[] ʤ롣
			ޤιԿʤСNULL 롣
******************************************************************************/
struct Figure_ {
	char name[MAXFIGURENAMELEN +1];	/* ̾ */
	char* fig[LINES - 5];			/* ƥȡʿޡˤؤΥݥ */
};

typedef struct Figure_ Figure;


/******************************************************************************
̾	Text
ڲ	ݰĤĤб롣
			ȤϥȤ򸫤ơ
			ϤʸʸϡԿʤСNULL 롣
******************************************************************************/
struct Text_ {
	char	textname[MAXLESSONNAMELEN + 1];		/* å̾ */
	Myfloat	timelim;							/* ԡȤɸ */
	Myfloat	errorlim;							/* 顼Ψɸ */
	char	figurename[MAXFIGURENAMELEN +1];	/* ޤ̾ */
	char*	string[LINES - 5];					/* Ϥʸɽʸ */
	char*	txt[MAXLIN];						/* ʸ */
	char	isclear;							/* ʺ (1)̤ (0) */
};

typedef struct Text_ Text;





/*ѿ*/

extern char*	txtfname;							/* ʸΥե̾ */
extern char*	figfname;							/* ޤΥե̾ */
extern int		lastlessonnum;						/* ǸΥåֹ */
extern Text*	txtptr[1 + MAXLESSONNUM + 1];
extern Figure*	figptr[MAXFIGURENUM];

extern char*	scrfname;							/* ե̾ */
extern char		scrfwrite;							/* 񤭽Ф */
extern char*	usrfname;							/* 桼ե̾ */
extern char		usrname[8+1];						/* 桼̾ */
extern int		lessonnum;							/* 貿ݡ */
extern char		scr[MAXSCORELIN][80+1];				/* ǶΥ */

extern int line;									/* ʸɽػϹ */

extern char lessonname[MAXLESSONNAMELEN+1];			/* ݤ̾ */
extern int strokes;									/* ʸǿ */
extern int your_strokes;							/* 桼ǿ */
extern int errors;									/* 顼ο */
extern time_t starttime;							/* ϻ */
extern time_t endtime;								/* λ */
extern int seconds;									/* ÿ */
extern int penalty;									/* ڥʥƥ */
extern Myfloat errorlim;							/* ɸ顼Ψ */
extern char str_errorlim[16];						/* ʸ */
extern Myfloat timelim;								/* ɸԡ */
extern char str_timelim[16];						/* ʸ */
extern char *copyright1;							/* ɽΣ */
extern char *copyright2;							/* ɽΣ */





/*ڴؿץȥ*/


	/* figure.c */

Figure* Figure_read(FILE *in);
void Figure_show(char *name);


	/* lesson.c */

void Lesson_init(void);
void Lesson_show(void);
void Lesson_next(void);
void Lesson_prev(void);
void Lesson_practice(void);


	/* main2.c */

void loop(void);


	/* misc.c */

int skip_space(FILE* in);
int myfgets(char *buf, int lim, FILE *in);
char* read1line(FILE *in);
void copyright(void);
void drawlines(void);
void showmenu(char* str);
void ending(char *msg, char *s);


	/* misc2.c */

void setscreen(void);
void endscreen(void);
void chmod_to_777(char*);
void chmod_to_755(char*);


	/* myfloat.c */

char* Myfloat_sprintf(char* t, Myfloat f);
int Myfloat_sscanf(char*, Myfloat*);
void Myfloat_init(Myfloat* fp, long num, long denom, int precision);
long Myfloat_cmp(Myfloat f, Myfloat g);
Myfloat Myfloat_div(Myfloat mf1, Myfloat mf2, int prec);


	/* quit2.c */

int quit(void);


	/* score.c */

void Score_init(void);
int Score_usrfwrite(void);
void Score_create(void);
int Score_write(void);


	/* sum.c */

unsigned long checksum(char*, char*);


	/* text.c */

Text* Text_read(FILE* in, int);


	/* time.c */
unsigned long struct_tm2sec(struct tm* tp);


#endif /* TX_H */
